-- author: rafftnix, SPARTAN_6
-- date: 31.01.2014

PlaceableCut = {}
local PlaceableCut_mt = Class(PlaceableCut, Placeable);
InitObjectClass(PlaceableCut, "PlaceableCut");

function PlaceableCut:new(isServer, isClient, mt)
	if mt == nil then
		mt = PlaceableCut_mt;
	end;
	
	local self = Placeable:new(isServer, isClient, mt);
	registerObjectClassName(self, "PlaceableCut");
	
	return self;
end;

function PlaceableCut:load(xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom)
	PlaceableCut:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom);
	if not moveMode then
		
		local xmlFile = loadXMLFile("temp", xmlFilename);

		-- remove grass under building
		local startNode = Utils.indexToObject(self.nodeId, getXMLString(xmlFile, "placeable.fruitCut#startIndex"));
		local widthNode = Utils.indexToObject(self.nodeId, getXMLString(xmlFile, "placeable.fruitCut#widthIndex"));
		local heightNode = Utils.indexToObject(self.nodeId, getXMLString(xmlFile, "placeable.fruitCut#heightIndex"));

		local sx, sy, sz = getWorldTranslation(startNode);
		local wx, wy, wz = getWorldTranslation(widthNode);
		local hx, hy, hz = getWorldTranslation(heightNode);
		
		Utils.destroyOtherFruit(FruitUtil.FRUITTYPE_GRASS, sx, sz, wx, wz, hx, hz);
		Utils.destroyOtherFruit(FruitUtil.FRUITTYPE_WHEAT, sx, sz, wx, wz, hx, hz);
		
		delete(xmlFile);
		

	end;
	
	return true;
end;

function PlaceableCut:delete()
	PlaceableCut:superClass().delete(self);
end;

function PlaceableCut:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	PlaceableCut:superClass().loadFromAttributesAndNodes(self, xmlFile, key, resetVehicles);
	return true;
end;

function PlaceableCut:getSaveAttributesAndNodes(nodeIdent)
	local attributes, nodes = PlaceableCut:superClass().getSaveAttributesAndNodes(self, nodeIdent);
	return attributes, nodes;
end;

function PlaceableCut:readStream(streamId, connection)
	PlaceableCut:superClass().readStream(self, streamId, connection);
end;

function PlaceableCut:writeStream(streamId, connection)
	PlaceableCut:superClass().writeStream(self, streamId, connection);
end;

function PlaceableCut:readUpdateStream(streamId, timestamp, connection)
	PlaceableCut:superClass().readUpdateStream(self, streamId, timestamp, connection);
end;

function PlaceableCut:writeUpdateStream(streamId, connection, dirtyMask)
	PlaceableCut:superClass().writeUpdateStream(self, streamId, connection, dirtyMask);
end;

function PlaceableCut:update(dt)
	PlaceableCut:superClass().update(self, dt);
end;

function PlaceableCut:updateTick(dt)
	PlaceableCut:superClass().updateTick(self, dt);
end;


function PlaceableCut:updateMoving(notNeeded)
end;


registerPlaceableType("PlaceableCut", PlaceableCut);